#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("DecompOutline");
#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_OUTLINE_H
FT_Library library;

#pragma comment(lib,"..\\..\\freetype237MT.lib")

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;

	// ̺귯 ʱȭ
	if (FT_Init_FreeType(&library)) {
		MessageBox(NULL,TEXT("FreeType ̺귯 ʱȭ "),
			TEXT(""),MB_OK);
		return -1;
	}

	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);

	while (GetMessage(&Message,NULL,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	// ̺귯 
	FT_Done_FreeType(library);
	return (int)Message.wParam;
}

class DrawOutline
{
#define TOINT(a) ((int)(a >> 6))
public:
	static POINT Base;
	static int nSleep;
	static int PathMoveTo(const FT_Vector *to, void *user)
	{
		HDC hdc=*(HDC *)user;
		MoveToEx(hdc,Base.x + TOINT(to->x),Base.y - TOINT(to->y),NULL);
		if (nSleep) Sleep(nSleep);
		return 0;
	}

	static int PathLineTo(const FT_Vector *to, void *user)
	{
		HDC hdc=*(HDC *)user;
		LineTo(hdc,Base.x + TOINT(to->x),Base.y - TOINT(to->y));
		if (nSleep) Sleep(nSleep);
		return 0;
	}

	static int PathConicTo(const FT_Vector *control, const FT_Vector *to, void *user)
	{
		HDC hdc=*(HDC *)user;
		POINT pts[3];
		pts[0].x=Base.x + TOINT(control->x);
		pts[0].y=Base.y - TOINT(control->y);
		pts[1].x=Base.x + TOINT(to->x);
		pts[1].y=Base.y - TOINT(to->y);
		pts[2].x=Base.x + TOINT(to->x);
		pts[2].y=Base.y - TOINT(to->y);
		PolyBezierTo(hdc,pts,3);
		if (nSleep) Sleep(nSleep);
		return 0;
	}

	static int PathCubicTo(const FT_Vector *control1, const FT_Vector *control2,const FT_Vector *to, void *user)
	{
		HDC hdc=*(HDC *)user;
		POINT pts[3];
		pts[0].x=Base.x + TOINT(control1->x);
		pts[0].y=Base.y - TOINT(control1->y);
		pts[1].x=Base.x + TOINT(control2->x);
		pts[1].y=Base.y - TOINT(control2->y);
		pts[2].x=Base.x + TOINT(to->x);
		pts[2].y=Base.y - TOINT(to->y);
		PolyBezierTo(hdc,pts,3);
		if (nSleep) Sleep(nSleep);
		return 0;
	}
};
POINT DrawOutline::Base;
int DrawOutline::nSleep=0;

void OnPaint(HDC hdc)
{
	FT_Face face;
	unsigned index;

	FT_New_Face(library,"c:\\windows\\fonts\\batang.ttc",2,&face);
	FT_Set_Char_Size(face, 256 * 64, 0, 
		GetDeviceCaps(hdc,LOGPIXELSX), GetDeviceCaps(hdc,LOGPIXELSY));
	index = FT_Get_Char_Index(face,L'');
	FT_Load_Glyph(face,index,FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP);

	// ܰ ׸.
	FT_Outline_Funcs outline_funcs = {
		DrawOutline::PathMoveTo, DrawOutline::PathLineTo, 
		DrawOutline::PathConicTo, DrawOutline::PathCubicTo, 0, 0
	};
	DrawOutline::Base.x=0;
	DrawOutline::Base.y=300;
	DrawOutline::nSleep=20;
	FT_Outline_Decompose(&face->glyph->outline, &outline_funcs, &hdc);

	FT_Done_Face(face);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

	switch (iMessage) {
	case WM_CREATE:
		hWndMain=hWnd;
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		OnPaint(hdc);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
